#include <stdio.h>
#include "pca_utils.h"
void daxpy(int n, double a, double *x, double *y, double *z) {
  int i;
  for (i=0; i<n; i++) {
    x[i] = (double)i*i;
    y[i] = (double)(i+1)*(i+1);
    z[i] = 0.0;
  }
  for (i=0; i<n; i++)
    z[i] += a*x[i] +y[i];
}
int main() {
  int n=10000000;
  double *x = vector(n);
  double *y = vector(n);
  double *z = vector(n);
  double a = 5./3.;
  pca_time tt;
  tick(&tt);
  daxpy(n,a,x,y,z);
  tock(&tt);
  free(z);
  free(y);
  free(x);
}
