program daxpy
    use pca_futils
    implicit none

    integer, parameter :: n=10000000
    double precision, allocatable:: x(:),y(:),z(:)
    integer :: i 
    integer :: timer
    real    :: time
    double precision    :: a

    allocate(x(n),y(n),z(n))

    a = 5./3.

    call tick(timer) 
    call calc_daxpy(n,a,x,y,z)
    call tock(timer)
 
    deallocate(x,y)

    contains

    subroutine calc_daxpy(n, a, x, y, z)
        implicit none
        integer, intent(in) :: n
        double precision, intent(in) :: a
        double precision, dimension(n), intent(out)  :: x
        double precision, dimension(n), intent(out)  :: y
        double precision, dimension(n), intent(out) :: z
        integer :: i

        do i=1,n
            x(i) = (i)*(i)
            y(i) = (i+1.)*(i-1.)
        enddo            
!! note - in FORTRAN we can just say y = a*x+b, but we'll
!! keep the loop explicit for now, so we may add openmp
        do i=1,n
            z(i) = a*x(i) + y(i)
        enddo
    end subroutine calc_daxpy

end program daxpy
