//omp_ndot_race.c
#include <stdio.h>
#include "pca_utils.h"

double ndot(int n, double *x, double *y)
    // this version of ndot will produce wrong answers because 
    // multiple threads will try to update tot at the same time.
{
  double tot=0;
  #pragma omp parallel shared(x,y,n,tot) 
  {
    double mytot = 0;
    #pragma omp for
    for (int i=0; i<n; i++)
      mytot += x[i] * y[i];
    #pragma omp atomic
    tot+=mytot;
  }
  return tot;
}

int main(int argc, char *argv[]) {
    int n=1e7;
    double *x = vector(n);
    double *y = vector(n);
    for (int i=0; i<n; i++) {
        x[i] = i;
        y[i] = i;
    }

    double nn=n-1;
    double ans=nn*(nn+1)*(2*nn+1)/6.0;
    pca_time tt;
    tick(&tt);
    double dot=ndot(n,x,y);
    printf("Dot product is %14.4e (vs %14.4e) for n=%d.\n"
           "Took %12.4e seconds.\n", 
	   dot, ans, n, tocksilent(&tt));
    return 0;
}
